# Plugins

### Build flexible architectures without compromising performance!

[![Build Status](https://travis-ci.com/tisztamo/Plugins.jl.svg?branch=master)](https://travis-ci.com/tisztamo/Plugins.jl)
[![Codecov](https://codecov.io/gh/tisztamo/Plugins.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/tisztamo/Plugins.jl)
![maturing](https://img.shields.io/badge/lifecycle-maturing-blue.svg)

[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://tisztamo.github.io/Plugins.jl/dev)

A plugin (aka extension) is a chunk of code that extends the functionality of a system. The plugin has its own lifecycle and it implements so-called hooks to react to events generated by the system.

The plugin-based architecture is a popular way to develop maintainable and extensible software, but its dynamic nature introduces a performance penalty that is not always acceptable. You tipically cannot hook into performance-critical points.

Plugins.jl helps by analyzing the plugins loaded into the system and generating a type chain to leverage the "Just Ahead Of Time" compilation of Julia, thus allowing full optimization.

With Plugins.jl, execution of plugin code can be just as performant as a manually composed system. *Inlinable hook implementations will be merged into a single function body, and non-implementing plugins are skipped with zero overhead.*

Interested? Please find more info in the [documentation](https://tisztamo.github.io/Plugins.jl/dev)!
